import pymt940
from argparse import ArgumentParser

parser = ArgumentParser()
parser.add_argument('-b', '--bank', type=str, default=None, help='bank shortname')
parser.add_argument('-f', '--filename', type=str, default=None, help='name of the csv')

args = vars(parser.parse_args())

args['bank'] = input('bank? ')
args['filename'] = input('file? ')

if args['bank'] == 'uni':
    uni = pymt940.Unicredit(args['filename'], 'RO50BACX0000001138725000')
    uni.convert()
else:
    transi = pymt940.Transi(args['filename'])
    transi.convert()

# uni = pymt940.Unicredit('export.csv', 'RO50BACX0000001138725000')
# uni.convert()
# for i in uni.trans_df.values:
#     print(i[14])

# transi.convert()
# for i in transi.trans_df.values:
#     print(i[2])

# ------------------------------------------------------------------------------------
# class mt940Test(unittest.TestCase):
#     def runTest(self):
#         print(str(date.today()).replace('-', ''))
#
#
# unittest.main()
# ------------------------------------------------------------------------------------
